Corpo di PartDesign

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page PartDesign Body and the translation is 61% complete.
Outdated translations are marked like this.
Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎русский
Arrow-left.svg Group.svg Gruppo Pagina precedente:
Pagina successiva: Creare uno schizzo PartDesign NewSketch.svg Arrow-right.svg

PartDesign Body.svg Corpo

Nome nel codice
PartDesign Body
Posizione nel menu
Part Design → Crea un corpo
Ambiente
PartDesign
Avvio veloce
Nessuno
Introdotto nella versione
0.17
Vedere anche
Parte standard, Editazione delle funzioni


Descrizione

Un Corpo di PartDesign è l'elemento base per creare forme solide con PartDesign. Può contenere schizzi, oggetti di riferimento e funzioni di PartDesign che aiutano a produrre un singolo solido contiguo.

Il Corpo fornisce un oggetto Origin che include gli assi X,Y,Z, e i piani standard. Questi elementi possono essere usati come riferimenti per collegare gli schizzi e gli oggetti primitivi.

Poiché si suppone che il Corpo sia un singolo solido contiguo, esso può essere spostato interamente come un'unità, senza spostare le singole funzioni. All'interno di una Parte standard è possibile posizionare più corpi per creare assiemi.

PartDesign Body tree.png PartDesign Body example.png

A sinistra: la vista ad albero che mostra le funzioni che producono in sequenza la forma finale dell'oggetto. A destra: l'oggetto finale visibile nella vista 3D.


Utilizzo

Se non è stato selezionato alcun solido precedente:

  1. Premere il pulsante PartDesign Body.svg Corpo. Viene creato un corpo vuoto che diventa automaticamente attivo.
  2. Ora si può premere PartDesign NewSketch.svg Nuovo schizzo per creare uno schizzo nel corpo. In seguito lo schizzo può essere utilizzato per creare una PartDesign Pad.svg Estrusione.
  3. In alternativa, si può aggiungere una funzione di PartDesign primitiva, ad esempio un PartDesign AdditiveBox.svg Cubo additivo.

Se viene selezionato un oggetto solido:

  1. Premere il pulsante PartDesign Body.svg Corpo. Viene creato un nuovo Corpo contenente una singola Base Feature. Questo elemento Base Feature è un semplice riferimento a un altro oggetto precedentemente creato o importato nel documento. Per maggiori informazioni vedere Funzione di base. Non è possibile selezionare un Corpo esistente o una funzione di PartDesign quando si preme PartDesign Body.svg Corpo.

Note

  • Se, quando si preme il pulsante PartDesign NewSketch.svg Nuovo schizzo della barra degli strumenti di PartDesign non esiste ancora un corpo, ne viene creato automaticamente uno nuovo. Se esiste già un corpo, esso deve essere reso attivo prima di usare PartDesign NewSketch.svg Nuovo schizzo.
  • Fare doppio clic su Corpo nella vista ad albero o aprire il menu di scelta rapida (clic con il tasto destro) e selezionare Attiva corpo per attivare o disattivare il corpo. Se un altro corpo è attivo, esso viene disattivato. Per maggiori informazioni vedere Stato attivo.

Proprietà

Un Corpo di PartDesign (classe PartDesign::Body) è derivato da una Part Feature (classe Part::Feature), pertanto condivide tutte le proprietà di quest'ultimo.

Oltre alle proprietà descritte in Part Feature, il corpo di PartDesign ha le seguenti proprietà nell'editor delle proprietà.

Dati

Base

  • DataTip (Link): è la funzione di PartDesign definita come "funzione finale", che è in genere l'ultima funzione creata nel corpo. La funzione finale indica la forma finale del corpo, che viene mostrata nella Vista 3D quando ViewDisplay Mode Body è impostata su Tip. Per maggiori informazioni vedere Tip.
  • DataBase Feature (Link): è una forma esterna usata come prima funzione di PartDesign nel Corpo. Di solito viene impostata quando si trascina un oggetto solido in un corpo vuoto. Se non viene importato nessun solido in questo modo, questa proprietà rimane vuota. Per maggiori informazioni vedere Funzione di base.
  • DataPlacement: la posizione dell'oggetto nella Vista 3D. Il posizionamento è definito da un punto Base (vettore) e una Rotation (asse e angolo). Vedere Posizionamento.
  • DataGroup: un elenco di funzioni di PartDesign nel Corpo

Proprietà dati nascoste

  • DataOrigin (Link): l'oggetto App Origin che è il riferimento posizionale per tutti gli elementi elencati nel DataGruppo.
  • Data_ Group Touched (Bool): se il gruppo viene toccato o no.

Oltre ale proprietà nascoste descritte in Part Feature il corpo di PartDesign ha le seguenti proprietà nell'editor delle proprietà.

Vista

Base

  • ViewDisplay Mode Body (Enumeration): imposta la modalità di visualizzazione nella vista 3D specifica per il corpo in uno dei due tipi.
    • Through (default) espone tutti gli oggetti all'interno del Corpo, ovvero schizzi, funzioni di PartDesign, oggetti di riferimento, ecc. Questa modalità consente di visualizzare le operazioni parziali eseguite all'interno del Corpo, quindi è la modalità raccomandata durante l'aggiunta e la modifica di funzioni. Selezionare la funzione desiderata e impostare ViewVisibility su true o premere la barra Spazio sulla tastiera.
    • Tip espone solo la forma finale del corpo, definita dalla proprietà DataTip. Tutto il resto, tra cui schizzi, funzioni di PartDesign, oggetti di riferimento, ecc., non viene visualizzato, anche se sono visibili nella vista ad albero. Questa modalità è consigliata quando non è necessario modificare ulteriormente il corpo, quindi viene visualizzata una forma finale. Questa modalità è consigliata anche quando si desidera selezionare gli elementi secondari (vertici, bordi e facce) della forma finale da utilizzare con gli strumenti di altri ambienti da lavoro.

Concetto di Corpo

Singolo solido contiguo

Il corpo PartDesign è progettato per modellare un singolo solido contiguo. Per "contiguo" si intende un elemento realizzato in un unico pezzo, senza parti mobili o solidi disconnessi. Esempi di solidi contigui sono quelli fabbricati da un singolo pezzo di materia prima mediante un processo di fusione, taglio o fresatura. Ad esempio, un dado, una rondella e un bullone sono costituiti ciascuno da un unico pezzo di acciaio solido senza parti mobili, quindi ciascuno di essi può essere modellato come un corpo PartDesign. Gli oggetti creati saldando due pezzi possono anche essere modellati in un singolo corpo, purché il giunto di saldatura non sia destinato a rompersi.

Quando questi solidi contigui vengono riuniti in un qualche tipo di disposizione, diventano un "assemblaggio". In un assemblaggio, gli oggetti non vengono fusi insieme, ma vengono semplicemente "impilati" o posizionati uno accanto all'altro e rimangono singole parti.

PartDesign Body contiguous separate.png PartDesign Body contiguous assembly.png

A sinistra: tre solidi contigui individuali, ciascuno modellato in un Corpo di PartDesign. A destra: i singoli Corpi riuniti in un'assemblaggio.


Editazione delle funzioni

Un corpo di PartDesign è progettato per funzionare creando un solido iniziale, da uno schizzo o da una forma primitiva, e quindi modificandolo tramite le "funzioni" per aggiungere o rimuovere materiale dalla forma precedente. Per una spiegazione completa, vedere la pagina editazione delle funzioni.

Un corpo di PartDesign esegue una fusione (unione) automatica degli elementi solidi al suo interno. Ciò significa che (1) i solidi parziali devono toccarsi quando vengono creati e (2) che i solidi disconnessi non sono consentiti.

PartDesign Body two intersection.png PartDesign Body two fusion.png

A sinistra: due singoli solidi che si intersecano. A destra: un singolo corpo di PartDesign creato con due funzioni additive, che vengono automaticamente fuse insieme, quindi invece di intersecarsi, formano un singolo solido contiguo.


PartDesign Body non-contiguous.png

A sinistra: due solidi disconnessi; questo non è un corpo PartDesign valido. A destra: due solidi che si toccano; ciò si traduce in un corpo PartDesign valido. La funzione più recente deve sempre contattare o intersecare la funzione precedente in modo che sia fusa con essa e diventi un singolo solido contiguo.


Nota: altri programmi CAD come Catia consentono solidi non contigui nello stesso "Corpo". A partire dalla versione 0.19, FreeCAD non lo consente. Ci sono state delle discussioni nel forum di FreeCAD sulla revoca di questa restrizione, ma non è stata presa alcuna decisione concreta. Se desiderate saperne di più o presentare punti di vista diversi, potete discuterne nel forum.

Spiegazione dettagliata delle proprietà

Stato attivo

Un documento aperto può contenere più corpi. Per aggiungere una nuova funzione a un corpo specifico, è necessario renderlo attivo. Un corpo attivo vinene visualizzato nella vista ad albero con il colore di sfondo specificato dal valore Active container nell'editor delle preferenze (per impostazione predefinita, blu). Un corpo attivo viene anche mostrato in grassetto.

Per attivare o disattivare un corpo:

  • Fare doppio clic su di esso nella vista ad albero, oppure
  • Aprire il menu contestuale (tasto destro) e selezionare Attiva/disattiva il corpo.

L'attivazione di un corpo commuta automaticamente anche l'interfaccia nell'ambiente PartDesign, se questo non era già l'ambiente attivo. Può essere attivo solo un singolo corpo per volta.

PartDesign Body active.png

Documento con due corpi PartDesign, di cui il secondo è attivo.


Origine

The Origin consists of the three standard axes (X, Y, Z) and three standard planes (XY, XZ and YZ). Sketches and other objects can be attached to these elements when creating them.

  1. Create the Body.
  2. If the Body is selected in the tree view, press PartDesign NewSketch.svg New sketch; the task panel will open to allow selecting one of the planes.
  3. If the Body is not selected, select the Origin instead and make it visible in the 3D view by pressing the Space bar in the keyboard. Also expand the Origin object to see the axes and planes.
  4. Select one of the planes, either in the tree view or in the 3D view, then press PartDesign NewSketch.svg New sketch. The sketch will be created on the chosen plane.

The same process can be used when creating auxiliary datum geometry like PartDesign Lines, PartDesign Planes, and PartDesign CoordinateSystems.

Note: the Origin is an App Origin object (App::Origin class), while the axes and planes are objects of type App::Line and App::Plane respectively. Each of these elements can be hidden and unhidden individually with the Space bar; this is useful to choose the correct reference when creating other objects.

Note 2: all elements inside the Body are referenced to the Body's Origin which means that the Body can be moved and rotated in reference to the global coordinate system without affecting the placement of the elements inside.

PartDesign Body Origin tree.png PartDesign Body Origin view.png

Left: PartDesign Body Origin in the tree view. Right: representation of the Origin elements in the 3D view.


Funzione di base

La Funzione di base, Base feature, è la prima Funzione PartDesign creata nel corpo quando il corpo si basa su un'altra forma solida. Questo solido può essere creato in qualsiasi ambiente di lavoro o importato da un file esterno, ad esempio un file STEP.

PartDesign Body BaseFeature tree.png

PartDesign Bodies, each of them with a single Base Feature, which are taken from previously created solids.


To create the Base Feature:

  1. select a solid shape external to any Body, and
  2. press PartDesign Body.svg Body; this will create a new Body with a single Base Feature.

Note: you can't select an existing Body, or any of its features, when pressing PartDesign Body.svg Body.

If you already have a Body, you can create the Base Feature in this way:

  • in the tree view, pick an object, and drag and drop it inside the Body, or
  • in the property editor, edit the value of DataBase Feature by pressing the ellipsis ..., and choosing an object from the list. In this case you can choose an existing Body to be the Base Feature.

Note: dragging and dropping only works for Bodies which don't have a Base Feature already.

Note 2: if the Body already has several features, when you drag and drop the external solid, the Base Feature will be created at the beginning of the list of features, that is, it will be added to the beginning of the DataGroup property.

The Base Feature is entirely optional; it is only present when including an object from outside the Body. If no external solid is included, you can still build your shape using sketches, pads, primitive objects, and other PartDesign Features. In this case the DataBase Feature property remains empty.

PartDesign Body BaseFeature Tip.svg

Left: PartDesign Body with a Base Feature that is taken from an external solid object, and many subsequent PartDesign Features on top. Right: Body which doesn't have an explicit Base Feature.


Tip

La cima o punta (Tip) è la PartDesign Feature del corpo che viene esposta all'esterno (quello che si vede). Viene automaticamente impostata sull'ultima funzione nella parte inferiore dell'albero; vale a dire che, se un altro strumento da qualsiasi ambiente di lavoro (ad esempio, Copia semplice o Sottrai di Part) deve utilizzare la forma del corpo, utilizzerà la forma della Punta. Detto in altro modo, la Punta è la rappresentazione finale del Corpo come se la storia parametrica non esistesse.

PartDesign Body Tip final.svg

Left: PartDesign Body with full parametric history including intermediate features. Right: the Tip is the final shape that can be exported from the Body, while omitting the model's history.


The Tip is automatically set to the last feature created in the Body. Nevertheless, it can also be set to any of the intermediate features by opening the tree view context menu (right-click) and choosing PartDesign MoveTip.svg Set tip, or by changing the Body's DataTip value in the property editor.

Changing the Tip in effect rolls back its history, making it possible to add features that should have been added earlier. It also exposes a different shape to external tools.

Nella vista ad albero, la funzione finale del corpo è riconoscibile dalla funzione di PartDesign che ha una icona sovrapposta costituita da una freccia bianca all'interno di un cerchio verde.

PartDesign Body Tip tree.png

Two PartDesign Bodies, each of them with PartDesign Features. The Tip is the last feature in them, and is marked with an overlay symbol.


Interazione con gli altri ambienti di lavoro

Per impostazione predefinita, le funzioni all'interno di un corpo sono selezionabili, e ovviamente ciò è necessario per poter modificare e aggiungere delle funzioni in PartDesign. Tuttavia, non è consigliabile selezionare le singole funzioni per utilizzarle con gli strumenti di altri ambienti di lavoro, come Part e Draft, poiché i risultati potrebbero essere inaspettati; in tal caso, nella vista rapporto potrebbe apparire un messaggio di errore, Links go out of the allowed scope.

Pertanto, per le interazioni con gli altri ambienti, dovrebbe essere selezionato solo il Corpo stesso dall'albero del modello. Nei casi in cui è necessario selezionare un sottoelemento specifico del Corpo (vertice, bordo, faccia), allora la proprietà vista ViewDisplay Mode Body del Corpo può essere modificata da Through (impostazione predefinita) a Tip. Questa proprietà è accessibile dal pannello Vista. In modalità Tip l'accesso agli oggetti sottostanti al Corpo (funzioni, riferimenti, schizzi) è disabilitato; nella vista 3D viene nascosto tutto tranne la funzione tip, indipendentemente da quale oggetto è impostato come visibile.

Una volta completate le operazioni in altri ambienti, non dimenticare di ripristinare la proprietà ViewDisplay Mode Body in Through per essere di nuovo in grado di modificare il corpo.

PartDesign Body Tip Display mode.svg

Left: when "Display Mode Body" is set to Through it is possible to select and perform operations with the individual PartDesign Features; in general, this is not recommended. Right: when "Display Mode Body" is set to Tip all selections and operations done on the Body will be done on the Tip, making sure only the final shape of the Body is exposed.


Gestione della visibilità

La visibilità del corpo prevale sulla visibilità di qualsiasi oggetto in esso contenuto. Se il corpo è nascosto, sono nascosti anche gli oggetti che esso contiene, anche se la loro proprietà ViewVisibility è impostata su true.

Multiple Sketches may be visible at one time, but only one PartDesign Feature (solid result) can be visible at a time. Selecting a hidden feature and pressing the Space bar in the keyboard will make it visible, and automatically hide the previously visible feature.

PartDesign Body Visibility.png

PartDesign Body: multiple Sketches may be visible simultaneously, but only one solid PartDesign Feature may be visible at one time, whether it is the Tip or not.


Attachment

PartDesign Features, just like planar objects, can be attached to different planes, usually the standard planes defined by the Body's Origin, or to custom PartDesign Planes.

Sketches are normally attached to a plane when they are created. In similar way, primitive features can also be attached. Attaching these objects to a plane allows them to be moved within the Body by changing their DataAttachment Offset property. For more information on the attachment modes see Part Attachment.

A PartDesign Feature that is not attached will be shown with a red overlay symbol next to their icon in the tree view.

PartDesign Body Feature attachment.png

PartDesign Body: PartDesign Features that are not attached to a plane or coordinate system will be shown with an overlay symbol next to their icon in the tree view.


Inheritance

A PartDesign Body is formally an instance of the class PartDesign::Body, whose parent is Part Feature (Part::Feature class) through the intermediate Part::BodyBase class, and is augmented with an Origin extension.

FreeCAD core objects.svg

Simplified diagram of the relationships between the core objects in the program. The PartDesign::Body object is intended to build parametric 3D solids, and thus is derived from the basic Part::Feature object, and has an Origin to control the placement of the features used inside of it.


Script

Vedere anche: Script di base per FreeCAD, e script di oggetti.

Vedere Part Feature per le informazioni generali sull'aggiunta di oggetti al documento.

Un corpo PartDesign viene creato con il metodo addObject() del documento. Quando esiste un Corpo, ad esso si possono aggiungere le funzioni con i metodi addObject() o addObjects() di questo Corpo.

import FreeCAD as App

doc = App.newDocument()
obj = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj.Label = "Custom label"

feat1 = App.ActiveDocument.addObject("PartDesign::AdditiveBox", "Box")
feat2 = App.ActiveDocument.addObject("PartDesign::AdditiveCylinder", "Cylinder")

obj.addObjects([feat1, feat2])
App.ActiveDocument.recompute()

In a document that has many Bodies, the active Body can be set using the setActiveObject method of the ActiveView. The first argument is the fixed string "pdbody", and the second argument is the Body object that should be made active.

import FreeCAD as App
import FreeCADGui as Gui

doc = App.newDocument()
obj1 = App.ActiveDocument.addObject("PartDesign::Body", "Body")
obj2 = App.ActiveDocument.addObject("PartDesign::Body", "Body")

Gui.ActiveDocument.ActiveView.setActiveObject("pdbody", obj1)
App.ActiveDocument.recompute()
Arrow-left.svg Group.svg Gruppo Pagina precedente:
Pagina successiva: Creare uno schizzo PartDesign NewSketch.svg Arrow-right.svg